#include <stdio.h>
#include <stdlib.h>
#include "CUnit/Basic.h"
#include "solving_03_01.h"
/* The suite initialization function.
 * Returns zero on success, non-zero otherwise.
 */
int init_suite1(void) {
  return 0;
}

/* The suite cleanup function.
 * Returns zero on success, non-zero otherwise.
 */
int clean_suite1(void) {
  return 0;
}


/**
 * test 1, 2, 4...
 *
 */
void testPowOf2(void) {
  
  
  CU_ASSERT(toBinary(0)==0);
  CU_ASSERT(toBinary(1)==1);
  CU_ASSERT(toBinary(2)==10);
  CU_ASSERT(toBinary(4)==100);
  CU_ASSERT(toBinary(8)==1000);
  CU_ASSERT(toBinary(16)==10000);
  CU_ASSERT(toBinary(32)==100000);
}

/**
 * test 3,7,15,31...
 *
 */

void testPowOf2Minus1(void) {
  CU_ASSERT(toBinary(3)==11);
  CU_ASSERT(toBinary(7)==111);
  CU_ASSERT(toBinary(15)==1111);
  CU_ASSERT(toBinary(31)==11111);
  CU_ASSERT(toBinary(63)==111111);
}




/**
 * simple tests for fill
 */
void testDifferent(void) {
  CU_ASSERT(toBinary(19)==10011);
  CU_ASSERT(toBinary(58)==111010);
  CU_ASSERT(toBinary(47)==101111);
  CU_ASSERT(toBinary(28)==11100);
  CU_ASSERT(toBinary(19)==10011);
  CU_ASSERT(toBinary(52)==110100);
  CU_ASSERT(toBinary(22)==10110);
}

/* The main() function for setting up and running the tests.
 * Returns a CUE_SUCCESS on successful running, another
 * CUnit error code on failure.
 */
int main()
{
   CU_pSuite pSuite = NULL;

   /* initialize the CUnit test registry */
   if (CUE_SUCCESS != CU_initialize_registry())
      return CU_get_error();

   /* add a suite to the registry */
   pSuite = CU_add_suite("Suite_1", init_suite1, clean_suite1);
   if (NULL == pSuite) {
      CU_cleanup_registry();
      return CU_get_error();
   }

   /* add the tests to the suite */
   /* NOTE - ORDER IS IMPORTANT - MUST TEST fread() AFTER fprintf() */
   if ((NULL == CU_add_test(pSuite, "test of 1, 2, 4....", testPowOf2)) ||
       (NULL == CU_add_test(pSuite, "test of 3, 7, 15...", testPowOf2Minus1)) ||
       (NULL == CU_add_test(pSuite, "test of different", testDifferent)))
   {
      CU_cleanup_registry();
      return CU_get_error();
   }

   /* Run all tests using the CUnit Basic interface */
   CU_basic_set_mode(CU_BRM_VERBOSE);
   CU_basic_run_tests();
   CU_cleanup_registry();
   return CU_get_error();
}
